/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates a celsius to fahrenheit converter
program implemented using three widgets attached to a 
bulletin board.
***************************************************************/

/* c2f.bb.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/BulletinB.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, button, bb, label, scale;

void buttonCB(w, client_data, call_data)
    Widget w;
    int client_data;
    XmPushButtonCallbackStruct *call_data;
/* handles the pushbutton's activate callback. */
{
    exit(0);
}

void scaleCB(w, client_data, call_data)
    Widget w;
    int client_data;
    XmScaleCallbackStruct *call_data;
/* handles the scale's callback. */
{
    char s[100];
    Arg al[10];
    int ac;

    sprintf(s,"farenheit=%d",call_data->value*9/5+32);
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate(s,char_set)); ac++;
    XtSetValues(label,al,ac);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* resize toplevel */
    ac=0;
    XtSetArg(al[ac],XmNheight,300); ac++;
    XtSetArg(al[ac],XmNwidth,200); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a bulletin board to hold the three widgets */
    ac=0;
    bb=XmCreateBulletinBoard(toplevel,"bb",al,ac);
    XtManageChild(bb);

    /* create a push button */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Quit",char_set)); ac++;
    button=XmCreatePushButton(bb,"button",al,ac);
    XtManageChild(button);
    XtAddCallback(button,XmNactivateCallback,buttonCB,NULL);

    /* create a scale */
    ac=0;
    XtSetArg(al[ac],XmNtitleString,
        XmStringCreate("Celsius Temperature",char_set)); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    XtSetArg(al[ac],XmNshowValue,True); ac++;
    scale=XmCreateScale(bb,"scale",al,ac);
    XtManageChild(scale);
    XtAddCallback(scale,XmNdragCallback,scaleCB,NULL);

    /* create a label */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Farenheit = 32",char_set)); ac++;
    label=XmCreateLabel(bb,"label",al,ac);
    XtManageChild(label);

    /* position widgets on the bulletin board */
    ac=0;
    XtSetArg(al[ac],XmNx,10); ac++;
    XtSetArg(al[ac],XmNy,10); ac++;
    XtSetValues(button,al,ac);

    ac=0;
    XtSetArg(al[ac],XmNx,1); ac++;
    XtSetArg(al[ac],XmNy,100); ac++;
    XtSetValues(scale,al,ac);

    ac=0;
    XtSetArg(al[ac],XmNx,10); ac++;
    XtSetArg(al[ac],XmNy,200); ac++;
    XtSetValues(label,al,ac);


    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}

